Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0039340
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] I. Performancemajoralways2018-09-21 22:062018-12-11 20:22
ReportergsuarezView Statuspublic 
Assigned ToAtulOpenbravo 
PrioritynormalResolutionfixedFixed in Version3.0PR19Q1
StatusclosedFix in branchFixed in SCM revision2c80088f99e5
ProjectionnoneETAnoneTarget Version
OSLinux 64 bitDatabasePostgreSQLJava version7.x
OS VersionOpenbravo Appliance 14.04Database version9.3.xAnt version1.9.x
Product VersionSCM revision 
Review Assigned ToSandrahuguet
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0039340: Performance issue in Budget window.

DescriptionIn environments with high amounts of lines inside a budget when user tries to export this budget to Excel and the export actual data flag is checked, it can take several hours.
This is caused by the update actuals process, the java class associated with this process tries to create the account natural tree using the getChildTree method from the TreeUtility class, in turn this method calls the private initialize and if the amount of treeNodes to process is big then the whole process takes hours. It doesn't represents a heap or cpu problem as they remain stable.
Steps To ReproduceIn an environment with a budget with a high amount of lines (150) and a high amount of tree nodes in any of elements of the nodes of the natural tree (20000):
- Set the 'Export actual data' flag as true in the budget.
- Export the budget to Excel using the process in that window.
TagsPerformance
Attached Files

- Relationships Relation Graph ] Dependency Graph ]
related to defect 0039461 closedAtulOpenbravo API Change: delete unused methods in TreeUtility 

-  Notes
(0107297)
AtulOpenbravo (developer)
2018-10-15 12:22

Test Plan

- In a local environment having 178 elements in Account Tree "F&B International Group Account Account" & its tree "F&B International Group Element Value (Account, etc.)"

- In Budget window select "F&B US, Inc." as organization, Year 2018.
- Export Actual Data = Yes.
- In budget Line select Account = 1000 Assets, Currency EUR, Amount = 100.
- Click on Export Budget To Excel.

Before fix it takes approx. 1 mins and after the fix it takes approx. 1 sec.
(0107299)
hgbot (developer)
2018-10-15 13:42

Repository: erp/devel/pi
Changeset: 2c80088f99e598c8d0263718a9be18a31d2da611
Author: Atul Gaware <atul.gaware <at> openbravo.com>
Date: Mon Oct 15 08:56:15 2018 +0530
URL: http://code.openbravo.com/erp/devel/pi/rev/2c80088f99e598c8d0263718a9be18a31d2da611 [^]

Fixes Issue 0039340: Performance issue in Budget window.

** Use Deque to avoid repeatative exploring of elements
in the tree. Deprecate old methods getNaturalTree, getChildTree,
getChildNode, Define new methods getChildrenOf, getChildrenOfTreeNode

** Move fetching of trees and treenodes in separated methods
getTreeIdsFromTreeType & getTreeIdsFromTreeType respectively.

---
M src/org/openbravo/erpCommon/ad_process/UpdateActuals.java
M src/org/openbravo/erpCommon/utility/TreeUtility.java
---
(0107300)
hgbot (developer)
2018-10-15 13:42

Repository: erp/devel/pi
Changeset: 0ac854acbc99ed823b508899b26051d5eb3caf2c
Author: Atul Gaware <atul.gaware <at> openbravo.com>
Date: Mon Oct 15 15:30:30 2018 +0530
URL: http://code.openbravo.com/erp/devel/pi/rev/0ac854acbc99ed823b508899b26051d5eb3caf2c [^]

Related To Issue 39340:Performance in budget window when exporting to excel.

** Add year from budget header as filter in the query.
** Use StringUtils.equals to avoid NPE.
** Use braces in if loops to make code more readable.
** Avoid printStackTrace()

---
M src/org/openbravo/erpCommon/ad_process/UpdateActuals.java
M src/org/openbravo/erpCommon/ad_reports/ReportBudgetExportExcel.java
---
(0107301)
hgbot (developer)
2018-10-15 13:42

Repository: erp/devel/pi
Changeset: 2e0dfe691859df46aa1549f9f285d3cb1a0da16f
Author: Sandra Huguet <sandra.huguet <at> openbravo.com>
Date: Mon Oct 15 13:42:19 2018 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/2e0dfe691859df46aa1549f9f285d3cb1a0da16f [^]

related to issue 39340 update Copyright year

---
M src/org/openbravo/erpCommon/ad_reports/ReportBudgetExportExcel.java
---
(0107302)
Sandrahuguet (developer)
2018-10-15 13:43

Code review + testing OK
(0107618)
hgbot (developer)
2018-10-26 12:14

Repository: erp/pmods/org.openbravo.materialmgmt.catalog
Changeset: 7d8e569372c81a190c8d1cbc7fa86804346110dd
Author: Atul Gaware <atul.gaware <at> openbravo.com>
Date: Tue Oct 16 11:49:59 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.materialmgmt.catalog/rev/7d8e569372c81a190c8d1cbc7fa86804346110dd [^]

Related To Issue 39340:CI eclipse warnings

** Use getChildTree instead of getChildNode as it is deprecated.
** Add copyright information.

---
M src/org/openbravo/materialmgmt/catalog/CatalogTreeDataSource.java
---
(0107767)
hgbot (developer)
2018-11-06 15:40

Repository: erp/devel/pi
Changeset: 98b93929cdd342b7e2819cbec546e2711bbe9e1b
Author: Sandra Huguet <sandra.huguet <at> openbravo.com>
Date: Tue Oct 16 15:54:26 2018 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/98b93929cdd342b7e2819cbec546e2711bbe9e1b [^]

related to issue 39340 delete deprecated methods and fix getChildNode

---
M src/org/openbravo/erpCommon/utility/TreeUtility.java
---
(0108428)
hudsonbot (developer)
2018-12-11 20:22

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/470e3cd384c5 [^]
Maturity status: Test
(0108429)
hudsonbot (developer)
2018-12-11 20:22

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/470e3cd384c5 [^]
Maturity status: Test
(0108430)
hudsonbot (developer)
2018-12-11 20:22

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/470e3cd384c5 [^]
Maturity status: Test
(0108452)
hudsonbot (developer)
2018-12-11 20:22

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/470e3cd384c5 [^]
Maturity status: Test

- Issue History
Date Modified Username Field Change
2018-09-21 22:06 gsuarez New Issue
2018-09-21 22:06 gsuarez Assigned To => platform
2018-09-21 22:06 gsuarez Modules => Core
2018-09-21 22:06 gsuarez Triggers an Emergency Pack => No
2018-09-24 10:47 alostale Assigned To platform => Triage Finance
2018-09-24 16:58 Sandrahuguet Assigned To Triage Finance => AtulOpenbravo
2018-09-24 16:59 Sandrahuguet Tag Attached: Performance
2018-10-02 17:57 AtulOpenbravo Status new => scheduled
2018-10-15 12:22 AtulOpenbravo Note Added: 0107297
2018-10-15 13:42 hgbot Checkin
2018-10-15 13:42 hgbot Note Added: 0107299
2018-10-15 13:42 hgbot Status scheduled => resolved
2018-10-15 13:42 hgbot Resolution open => fixed
2018-10-15 13:42 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/devel/pi/rev/2c80088f99e598c8d0263718a9be18a31d2da611 [^]
2018-10-15 13:42 hgbot Checkin
2018-10-15 13:42 hgbot Note Added: 0107300
2018-10-15 13:42 hgbot Checkin
2018-10-15 13:42 hgbot Note Added: 0107301
2018-10-15 13:43 Sandrahuguet Review Assigned To => Sandrahuguet
2018-10-15 13:43 Sandrahuguet Note Added: 0107302
2018-10-15 13:43 Sandrahuguet Status resolved => closed
2018-10-15 13:43 Sandrahuguet Fixed in Version => 3.0PR19Q1
2018-10-16 16:16 Sandrahuguet Relationship added related to 0039461
2018-10-26 12:14 hgbot Checkin
2018-10-26 12:14 hgbot Note Added: 0107618
2018-11-06 15:40 hgbot Checkin
2018-11-06 15:40 hgbot Note Added: 0107767
2018-12-11 20:22 hudsonbot Checkin
2018-12-11 20:22 hudsonbot Note Added: 0108428
2018-12-11 20:22 hudsonbot Checkin
2018-12-11 20:22 hudsonbot Note Added: 0108429
2018-12-11 20:22 hudsonbot Checkin
2018-12-11 20:22 hudsonbot Note Added: 0108430
2018-12-11 20:22 hudsonbot Checkin
2018-12-11 20:22 hudsonbot Note Added: 0108452


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker